SystemOrganization addCategory: #'Sitemap-Command'!
SystemOrganization addCategory: #'Sitemap-Model'!
SystemOrganization addCategory: #'Sitemap-View'!

PRRawView subclass: #SitemapDownloadView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

SitemapDownloadView subclass: #SitemapDownloadGzipView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

!SitemapDownloadGzipView class methodsFor: 'testing' stamp: 'pmm 2/4/2007 23:47'!
label
	^'Download (GZIP)'! !

!SitemapDownloadGzipView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:15'!
content
	^self generator xmlStringGZipCompressed! !

!SitemapDownloadGzipView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:15'!
fileName
	^'sitemap.gz'! !

!SitemapDownloadGzipView methodsFor: 'accessing' stamp: 'pmm 1/8/2007 10:31'!
mimeType
	self flag: #xxx. "gzip is the encoding"
	^'application/gzip'! !

SitemapDownloadView subclass: #SitemapDownloadPlainView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

!SitemapDownloadPlainView class methodsFor: 'accessing' stamp: 'pmm 2/4/2007 23:47'!
label
	^'Download (XML)'! !

!SitemapDownloadPlainView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:10'!
content
	^self generator xmlString! !

!SitemapDownloadPlainView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:55'!
fileName
	^'sitemap.xml'! !

!SitemapDownloadPlainView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:55'!
mimeType
	^'text/xml'! !

!SitemapDownloadView class methodsFor: 'testing' stamp: 'pmm 2/4/2007 23:59'!
isAbstract
	^self name = #SitemapDownloadView! !

!SitemapDownloadView class methodsFor: 'testing' stamp: 'pmm 2/4/2007 23:46'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: Sitemap ]! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 3/3/2006 21:11'!
content
	self subclassResponsibility ! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 3/3/2006 21:11'!
fileName
	self subclassResponsibility ! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/4/2007 23:43'!
generator
	^SitemapGenerator generate! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 3/3/2006 21:11'!
mimeType
	self subclassResponsibility ! !

!SitemapDownloadView methodsFor: 'rendering' stamp: 'pmm 2/11/2006 10:48'!
renderContentOn: aRequest
	aRequest 
		contentType: self mimeType;
		attachmentWithFileName: self fileName;
		nextPutAll: self content! !

PRStructure subclass: #Sitemap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

!Sitemap class methodsFor: 'accessing-resources' stamp: 'pmm 2/4/2007 23:32'!
googleIcon
	"PRCompatibility compileFileNamed: 'google.png' into: GoogleSitemap class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 0 72 0 0 0 72 0 70 201 107 62 0 0 2 230 73 68 65 84 56 203 157 147 75 139 91 117 0 71 207 125 36 55 153 56 201 60 209 209 116 58 142 20 181 216 42 74 157 130 248 64 208 141 149 10 5 23 182 43 139 32 136 46 74 183 130 138 238 92 136 118 211 149 130 136 8 110 212 133 34 3 42 165 130 193 233 180 153 161 47 107 134 97 198 105 147 76 38 207 155 123 111 110 238 255 231 34 31 64 240 124 128 179 58 199 242 78 223 209 241 19 175 211 161 137 23 20 49 233 22 253 84 142 169 184 74 104 50 224 78 210 164 195 140 19 17 88 227 164 226 54 155 78 138 130 113 1 224 209 147 215 213 31 212 37 73 177 31 200 104 75 117 25 197 146 182 251 210 230 198 174 58 146 90 173 80 81 34 169 47 105 16 74 237 72 127 30 94 148 187 99 205 99 167 178 68 64 127 44 67 181 91 228 235 111 107 220 42 253 78 169 108 211 15 103 169 185 117 14 29 244 120 230 216 18 175 60 110 113 228 126 135 156 233 98 135 21 152 61 189 42 163 80 13 245 245 155 47 189 120 182 164 233 39 126 214 223 117 169 42 105 40 233 142 164 63 174 73 197 163 31 235 225 199 206 106 111 79 82 87 186 50 225 137 133 83 37 25 109 41 148 244 198 71 215 245 192 145 243 170 69 146 209 150 6 166 41 13 19 133 201 200 180 114 171 171 82 121 93 129 186 82 212 85 249 161 130 216 247 230 109 249 177 244 254 249 13 221 253 212 103 90 187 17 41 144 20 106 71 45 5 10 181 169 64 109 41 144 226 193 72 228 171 173 68 85 173 28 68 174 219 178 176 93 216 179 198 72 37 139 60 82 76 67 18 35 39 143 23 123 180 83 243 88 64 38 241 33 147 67 248 216 12 177 227 105 76 45 143 157 142 247 8 48 252 176 126 25 22 135 152 177 26 88 6 43 206 65 98 81 72 32 159 0 86 26 199 128 193 38 33 1 137 41 215 197 110 228 115 8 27 183 49 5 77 97 71 147 208 53 40 229 211 77 25 136 65 78 4 25 72 108 225 152 44 89 4 170 16 101 246 97 123 73 139 52 80 156 158 96 251 198 14 145 51 128 113 143 168 147 99 220 177 241 51 80 195 112 177 82 101 181 30 179 86 131 149 245 44 198 155 160 237 92 193 246 236 12 54 187 28 125 50 6 231 65 62 60 183 70 211 142 176 243 192 16 198 8 184 185 154 225 237 83 151 120 233 185 239 56 113 236 71 150 151 43 200 228 201 89 115 176 255 213 64 146 116 59 148 22 14 95 84 97 234 115 45 95 147 2 197 50 146 212 107 72 67 41 138 165 203 255 72 179 251 223 211 151 223 172 200 104 75 151 102 230 100 15 178 219 8 159 25 111 147 95 127 90 98 110 102 151 227 207 126 197 167 159 84 168 14 32 201 165 105 57 61 122 46 108 52 98 234 189 171 120 227 62 0 153 92 15 107 246 173 178 110 158 59 132 103 70 111 52 35 195 153 119 127 225 194 247 107 68 222 36 164 14 224 228 7 132 245 187 40 220 83 229 133 231 125 62 56 243 50 247 101 179 148 23 230 97 233 228 85 169 51 42 239 191 232 15 146 81 219 161 164 126 95 127 29 184 87 110 234 181 119 120 250 2 255 139 47 252 29 254 5 25 110 13 171 255 102 75 149 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!Sitemap class methodsFor: 'testing' stamp: 'pmm 2/4/2007 23:52'!
isAbstract
	^false! !

!Sitemap class methodsFor: 'accessing' stamp: 'pmm 2/4/2007 23:37'!
label
	^'Sitemap'! !

!Sitemap class methodsFor: 'accessing-resources' stamp: 'pmm 2/4/2007 23:24'!
yahooIcon
	"PRCompatibility compileFileNamed: 'yahoo-1.png' into: YahooSitemap class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 0 72 0 0 0 72 0 70 201 107 62 0 0 0 97 73 68 65 84 56 203 237 82 65 14 192 48 8 130 253 255 207 246 178 46 148 97 60 47 153 151 38 136 128 166 192 95 44 160 218 38 192 81 224 126 171 2 56 25 24 23 80 178 186 111 156 65 244 234 34 111 146 15 187 123 220 209 99 235 176 165 60 19 164 36 201 89 241 40 48 28 141 42 250 82 238 174 78 57 94 72 232 26 157 249 211 31 255 199 135 106 1 251 54 26 19 91 24 94 77 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!Sitemap methodsFor: 'visiting' stamp: 'pmm 2/4/2007 23:36'!
accept: aVisitor
	aVisitor visitSitemap: self! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 3/3/2006 21:10'!
loginText
	self subclassResponsibility ! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 3/3/2006 21:10'!
loginUrl
	self subclassResponsibility! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 3/3/2006 21:11'!
logoHeight
	self subclassResponsibility! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 3/3/2006 21:11'!
logoText
	self subclassResponsibility! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 3/3/2006 21:11'!
logoUrl
	self subclassResponsibility! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 3/3/2006 21:11'!
logoWidth
	self subclassResponsibility! !

!PRViewRenderer methodsFor: '*Sitemap' stamp: 'pmm 3/5/2007 17:33'!
visitSitemap: aSitemap

	html paragraph: [
		html anchor
			url: 'https://www.google.com/webmasters/sitemaps/login';
			with: [
				html image
					width: 176;
					height: 77;
					altText: 'Login at Google Sitemaps';
					url: 'https://www.google.com/webmasters/tools/images/logo_wht_60.gif'.] ].

	html paragraph: [.
		html anchor
			url: 'http://submit.search.yahoo.com/free/request';
			with: [
				html image
					width: 230;
					height: 33;
					altText: 'Login at Yahoo!! Sitemaps';
					url: 'http://sec.yimg.com/i/us/nt/ma/ma_search_1.gif'] ].
	
	html anchor
		url: 'http://www.sitemaps.org/';
		with: 'sitemaps.org'! !

!PRVisitor methodsFor: '*Sitemap' stamp: 'pmm 2/4/2007 23:21'!
visitSitemap: aSitemap
	self visitStructure: aSitemap! !

PRVisitor subclass: #SitemapGenerator
	instanceVariableNames: 'document root context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

!SitemapGenerator commentStamp: '<historical>' prior: 0!
http://www.google.com/schemas/sitemap/0.84/
https://www.google.com/webmasters/sitemaps/docs/en/protocol.html
http://www.xml.com/pub/a/2005/10/26/google-site-maps.html
http://sitemaps.blogspot.com/2005/09/using-oai-pmh-with-google-sitemaps.html!

!SitemapGenerator class methodsFor: 'instance creation' stamp: 'pmm 2/4/2007 23:42'!
generate
	^self new generate! !

!SitemapGenerator methodsFor: 'private' stamp: 'pmm 12/8/2007 22:10'!
add: aCase
	| url location timestamp lastModification isoString |
	url := XMLElement named: 'url'.
	location := XMLElement named: 'loc'.
	location addContent: (XMLStringNode string: (self urlOf: aCase)).
	url addElement: location.
	"not supported anymore by Pier
	timestamp := aCase modificationTimestamp.
	timestamp isNil ifFalse: [
		lastModification := XMLElement named: 'lastmod'.
		isoString := String streamContents: [ :stream | 
			timestamp printOn: stream withLeadingSpace: false ].
		lastModification addContent: (XMLStringNode string: isoString).
		url addElement: lastModification ]."
	self root addElement: url! !

!SitemapGenerator methodsFor: 'testing' stamp: 'pmm 9/30/2007 12:28'!
canSee: aStructure
	| command ctxt |
	command := aStructure viewCommandClass new.
	ctxt := context structure: aStructure command: command.
	[ aStructure validateCommand: command ]
		on: MAError
		do: [ ^false ].
	^true! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/4/2007 23:54'!
context
	context isNil ifTrue: [
		context := PRCurrentContext value ].
	^context! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
document
	^document! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
document: anXmlDocument 
	document := anXmlDocument! !

!SitemapGenerator methodsFor: 'public' stamp: 'pmm 2/4/2007 23:42'!
generate
	^self visit: self context root! !

!SitemapGenerator methodsFor: 'private' stamp: 'pmm 12/8/2007 22:11'!
hasPierBlog
	^self class environment hasClassNamed: #PBEntry! !

!SitemapGenerator methodsFor: 'private' stamp: 'pmm 3/5/2007 17:14'!
hasSpielverderber
	^self class environment hasClassNamed: #SVUserManagement! !

!SitemapGenerator methodsFor: 'testing' stamp: 'pmm 12/8/2007 22:13'!
ignore: aPage
	^aPage name = 'environment'
		or: [
			self hasSpielverderber
				and: [ aPage isKindOf: (Smalltalk classNamed: #SVUserManagement) ] ]
		or: [
			self hasPierBlog
				and: [ aPage isKindOf: (Smalltalk classNamed: #PBEntry) ]
				and: [ aPage publication isNil or: [ aPage publication > TimeStamp now ] ] ]! !

!SitemapGenerator methodsFor: 'testing' stamp: 'pmm 2/4/2007 23:41'!
ignoreChildrenOf: aPage
	^self ignore: aPage! !

!SitemapGenerator methodsFor: 'initialize-release' stamp: 'pmm 1/8/2007 10:28'!
initialize
	super initialize.
	self document: (XMLDocument new
		version: '1.0';
		encoding: 'UTF-8';
		yourself).
	self root: (XMLElement named: 'urlset').
	self root attributeAt: 'xmlns' put: 'http://www.sitemaps.org/schemas/sitemap/0.9'.
	self root attributeAt: 'xmlns:xsi' put: 'http://www.w3.org/2001/XMLSchema-instance'.
	self root attributeAt: 'xsi:schemaLocation' put: 'http://www.sitemaps.org/schemas/sitemap/0.9
	http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd'.
	document addElement: root
	! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
root
	^root! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:56'!
root: anXmlElement 
	root := anXmlElement! !

!SitemapGenerator methodsFor: 'private' stamp: 'pmm 2/4/2007 23:56'!
urlOf: aStructure
	^(self context structure: aStructure) url asString! !

!SitemapGenerator methodsFor: 'visiting-structure' stamp: 'pmm 9/30/2007 12:11'!
visitCase: aCase
	((self ignore: aCase) not
		and: [ self canSee: aCase ])
			ifTrue: [ self add: aCase ].! !

!SitemapGenerator methodsFor: 'visiting-decoration' stamp: 'pmm 2/4/2007 23:41'!
visitChildren: anObject
	| decorated |
	decorated := anObject decorated.
	(self ignoreChildrenOf: decorated) ifFalse: [
		decorated enumerator do: [ :each |
			self visit: each ] ]! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/9/2005 00:22'!
xmlString
	^String streamContents: [ :stream |
		self document printCanonicalOn: stream ].! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/3/2006 22:42'!
xmlStringGZipCompressed
	^String streamContents: [ :stream |
		| gzipStream |
		gzipStream := GZipWriteStream on: stream.
		self document printCanonicalOn: gzipStream.
		gzipStream close ].! !

PRCommand subclass: #SitemapPingCommand
	instanceVariableNames: 'searchengineUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Command'!

!SitemapPingCommand commentStamp: 'pmm 11/18/2006 20:09' prior: 0!
http://www.sitemaps.org/faq.html#faq_after_submission!

!SitemapPingCommand class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 23:10'!
descriptionSearchengineUrl
	^ MAStringDescription new
		selector: #searchengineUrl;
		label: 'Searchengine URL';
		priority: 200;
		beRequired;
		yourself! !

!SitemapPingCommand class methodsFor: 'testing' stamp: 'pmm 11/18/2006 20:08'!
isAbstract
	^false! !

!SitemapPingCommand class methodsFor: 'accessing' stamp: 'pmm 11/18/2006 20:09'!
label
	^'Ping'! !

!SitemapPingCommand class methodsFor: 'accessing' stamp: 'pmm 11/18/2006 20:12'!
structureClass
	^ GoogleSitemap! !

!SitemapPingCommand methodsFor: 'events' stamp: 'pmm 11/18/2006 20:31'!
doCurl
	| curl |
	curl := (Smalltalk classNamed: #Curl) new.
	curl getContentsUrl: self pingUrl asString.
	^curl easyStatus! !

!SitemapPingCommand methodsFor: 'events' stamp: 'pmm 2/4/2007 19:59'!
doExecute
	(Smalltalk hasClassNamed: 'Curl')
		ifTrue: [ self doCurl ]
		ifFalse: [ self doHttpSocket ]! !

!SitemapPingCommand methodsFor: 'events' stamp: 'pmm 11/18/2006 20:34'!
doHttpSocket
	| url |
	url := self pingUrl.
	^HTTPSocket httpGet: url hostname args: url parameters accept: '*/*' request: ''! !

!SitemapPingCommand methodsFor: 'private' stamp: 'pmm 11/18/2006 20:25'!
pingUrl
	| url |
	url := WAUrl new
		hostname: self searchengineUrl.
	url addParameter: 'ping'.
	url addParameter: 'sitemap' value: self viewGzipUrl asString.
	^url! !

!SitemapPingCommand methodsFor: 'accessing' stamp: 'pmm 11/18/2006 20:10'!
searchengineUrl
	^searchengineUrl! !

!SitemapPingCommand methodsFor: 'accessing' stamp: 'pmm 11/18/2006 20:10'!
searchengineUrl: aString 
	searchengineUrl := aString! !

!SitemapPingCommand methodsFor: 'private' stamp: 'pmm 2/4/2007 23:47'!
viewGzipUrl
	| ctxt |
	ctxt := self context.
	^(ctxt 
		structure: ctxt structure
		view: SitemapDownloadGzipView) url! !
